diff --git a/tests/generic_gpio_liblocal.c b/tests/generic_gpio_liblocal.c
index d8ad77074a..afd7ec32f9 100644
--- a/tests/generic_gpio_liblocal.c
+++ b/tests/generic_gpio_liblocal.c
@@ -75,17 +75,18 @@ void setNextLinesReadToFail(void) {
 int gpiod_line_get_value_bulk(struct gpiod_line_bulk *bulk,
 			      int *values)
 {
+	int	pinPos = 1;
 	NUT_UNUSED_VARIABLE(bulk);
+
 	if(errReqFor_line_get_value_bulk) {
 		errReqFor_line_get_value_bulk=0;
 		errno = EPERM;
 		return -1;
 	}
-	int pinPos=1;
-		for(unsigned int i=0; i<num_lines; i++) {
-			values[i]=(gStatus&pinPos)!=0;
-			pinPos=pinPos<<1;
-		}
+	for(unsigned int i=0; i<num_lines; i++) {
+		values[i]=(gStatus&pinPos)!=0;
+		pinPos=pinPos<<1;
+	}
 
 	gStatus++;
 	return 0;
diff --git a/tests/generic_gpio_utest.c b/tests/generic_gpio_utest.c
index b2f5e9b443..542438b021 100644
--- a/tests/generic_gpio_utest.c
+++ b/tests/generic_gpio_utest.c
@@ -133,13 +133,14 @@ void exit(int code)
 }
 
 int main(int argc, char **argv) {
-	test_with_exit=0;
 	int jmp_result;
 	char rules[128];
 	char testType[128];
 	char testDescFileNameBuf[LARGEBUF];
 	char *testDescFileName="generic_gpio_test.txt";
 
+	test_with_exit=0;
+
 	if(argc==2) {
 		testDescFileName=argv[1];
 	}
@@ -183,8 +184,8 @@ int main(int argc, char **argv) {
 		fEof=fscanf(testData, "%s", rules);
 		if(fEof!=EOF) {
 			if(!strcmp(testType, "rules")) {
-				jmp_result = setjmp(env_buffer);
 				struct gpioups_t *upsfdtest=xcalloc(sizeof(*upsfdtest),1);
+				jmp_result = setjmp(env_buffer);
 				if(jmp_result) {	/* test case  exiting */
 					generic_gpio_close(upsfdtest);
 					printf("%s %s test rule %d [%s]\n", pass_fail[get_test_status(upsfdtest, 1)], testType, i, rules);
@@ -226,6 +227,11 @@ int main(int argc, char **argv) {
 				char chargeLow[256];
 				char charge[256];
 				struct gpioups_t *upsfdtest=xcalloc(sizeof(*upsfdtest),1);
+				int failed = 0;
+				const char *currUpsStatus=NULL;
+				const char *currChargerStatus=NULL;
+				const char *currCharge=NULL;
+
 				get_ups_rules(upsfdtest, (unsigned char *)rules);
 				upsfdtest->upsLinesStates=xcalloc(sizeof(int),upsfdtest->upsLinesCount);
 				for(int j=0; j<upsfdtest->upsLinesCount; j++) {
@@ -238,10 +244,6 @@ int main(int argc, char **argv) {
 				if(strcmp(chargeLow, "."))
 					dstate_setinfo("battery.charge.low", "%s", chargeLow);
 				jmp_result = setjmp(env_buffer);
-				int failed=0;
-				const char *currUpsStatus=NULL;
-				const char *currChargerStatus=NULL;
-				const char *currCharge=NULL;
 				if(jmp_result) {
 					failed=1;
 					generic_gpio_close(upsfdtest);
@@ -270,13 +272,13 @@ int main(int argc, char **argv) {
 			}
 			if(!strcmp(testType, "library")) {
 				char chipNameLocal[NUT_GPIO_CHIPNAMEBUF];
-				int expecting_failure;
+				int expecting_failure, failed;
 				char subType[NUT_GPIO_SUBTYPEBUF];
 				fEof=fscanf(testData, "%d", &expecting_failure);
 				fEof=fscanf(testData, "%s", chipNameLocal);
 				fEof=fscanf(testData, "%s", subType);
 				jmp_result = setjmp(env_buffer);
-				int failed=expecting_failure;
+				failed = expecting_failure;
 				if(jmp_result) {	/* test case  exiting */
 					if(expecting_failure) failed=0;
 					upsdrv_cleanup();
